#!/usr/bin/env python3

import sys
from fp import FP
from expression import Expression2, Expression2Mode


if "__main__" == __name__:
	if len(sys.argv) != 7:
		sys.stderr.write("Usage: eval.py mode ac ae bc be x\n");
		sys.stderr.write("\tmode\tOrdem de operação em parcelas do tipo (ac)x^-(ae):\n")
		sys.stderr.write("\t\t0: Realiza (1/(x^(ae))) * (ac)\n")
		sys.stderr.write("\t\t1: Realiza (ac)/(x^(ae))\n")
		sys.stderr.write("\tac\tCoeficiente a\n")
		sys.stderr.write("\tae\tExpoente a\n")
		sys.stderr.write("\tbc\tCoeficiente b\n")
		sys.stderr.write("\tbe\tExpoente b\n")
		sys.stderr.write("\tx\tValor a ser avaliado\n")
		sys.stderr.write("\nAvalia x na função f(x) = ac * (x^ae) + bc * (x^be)\n")
		sys.stderr.write("\nUtilizando representação ponto-fixo 4 bits int 4 bits frac\n")
		exit(1)

	mode = int(sys.argv[1])
	ac = float(sys.argv[2])
	ae = float(sys.argv[3])
	bc = float(sys.argv[4])
	be = float(sys.argv[5])
	x = float(sys.argv[6])

	if 0 == mode:
		mode = Expression2Mode.ONE_BY_X
	else:
		mode = Expression2Mode.N_BY_X

	e = Expression2(ac, ae, bc, be)

	val = e.evalFP(x, mode=mode)
	xFP = FP(x)
	print("DEC:")
	print("\t{}".format(e))
	print("\tf({}) = {}".format(x, val))
	print("BIN:")
	print("\t{}".format(e.binStr()))
	print("\tf({}) = {}".format(str(bin(xFP._val & 0b11111111))[2:], str(bin(val._val & 0b11111111))[2:]))
